/* $Id: plugin_coadmins.sma,v 1.0 2002/04/01 blutig geist $ */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.00";

new UserNaming[MAX_PLAYERS] = {0,...};
new UserTimers[MAX_PLAYERS] = {0,...};

public CheckName(UserName[], OldName[], NewName[]) {
	new i;

	strcpy(NewName, OldName, MAX_NAME_LENGTH);
	i = strlen(NewName)-1;
	while (NewName[i] == '*') {
		NewName[i] = 0;
		i--;
	}
	if(access(ACCESS_KICK, UserName)!=0) {
		strcat(NewName, "*", MAX_NAME_LENGTH);
	}
	if(streq(OldName,NewName)==0) {
		return 0;
	}
	return 1;
}

public CheckNameAll(Timer,Repeat,HLUser,HLParam) {
	new Name[MAX_NAME_LENGTH];
	new NewName[MAX_NAME_LENGTH];
	new SessionID;
	new WONID;
	new Team;
	new Dead;
	new i;
	new maxplayers = maxplayercount();
	new Command[MAX_TEXT_LENGTH];

	for(i=1; i<=maxplayers; i++) {
		if(UserTimers[i] == 0) {
			strinit(Name);
			if(playerinfo(i,Name,MAX_NAME_LENGTH,SessionID,WONID,Team,Dead)==1) {
				if(CheckName(Name, Name, NewName)==0) {
					UserNaming[i] = 1;
					snprintf(Command, MAX_TEXT_LENGTH, "name %c%s%c", '"', NewName, '"');
					execclient(Name,Command);
				}
			}
		}
	}
}

public Wait4Live(Timer,Repeat,HLUser,HLParam) {
	new Param[MAX_DATA_LENGTH];
	new UserIndex;
	new Name[MAX_NAME_LENGTH];
	new NewName[MAX_NAME_LENGTH];
	new SessionID;
	new WONID;
	new Team;
	new Dead;
	new Command[MAX_TEXT_LENGTH];

	convert_string(HLParam,Param,MAX_NAME_LENGTH);
	UserIndex = strtonum(Param);
	if(playerinfo(UserIndex,Name,MAX_NAME_LENGTH,SessionID,WONID,Team,Dead)==1) {
		if(Dead!=1) {
			kill_timer(UserTimers[UserIndex]);
			UserTimers[UserIndex] = 0;
			if(CheckName(Name, Name, NewName)==0) {
				UserNaming[UserIndex] = 1;
				snprintf(Command, MAX_TEXT_LENGTH, "name %c%s%c", '"', NewName, '"');
				execclient(Name,Command);
			}
		}
	}
}

public plugin_info(HLOldName,HLNewName,UserIndex) {
	new OldName[MAX_NAME_LENGTH];
	new NewName[MAX_NAME_LENGTH];
	new Command[MAX_TEXT_LENGTH];
	new Name[MAX_NAME_LENGTH];
	new SessionID;
	new WONID;
	new Team;
	new Dead;
	new Param[MAX_DATA_LENGTH];

	if(UserNaming[UserIndex]==1) {
		UserNaming[UserIndex] = 0;
		playerinfo(UserIndex,Name,MAX_NAME_LENGTH,SessionID,WONID,Team,Dead);
		if(Dead==1) {
			return PLUGIN_HANDLED;
		}
		else {
			return PLUGIN_CONTINUE;
		}
	}

	if(playerinfo(UserIndex,Name,MAX_NAME_LENGTH,SessionID,WONID,Team,Dead)==1) {
		convert_string(HLOldName, OldName, MAX_NAME_LENGTH);
		convert_string(HLNewName, NewName, MAX_NAME_LENGTH);
		if((Dead==1) && (streq(OldName,NewName)!=0)) {
			if(UserTimers[UserIndex]==0) {
				snprintf(Param, MAX_DATA_LENGTH, "%i", UserIndex);
				UserTimers[UserIndex]=set_timer("Wait4Live", 5, 99999, Param);
			}
			return PLUGIN_CONTINUE;
		}
		if(CheckName(OldName, NewName, Name)==0) {
			UserNaming[UserIndex] = 1;
			snprintf(Command, MAX_TEXT_LENGTH, "name %c%s%c", '"', Name, '"');
			execclient(OldName,Command);
		}
		if(Dead==1) {
			return PLUGIN_HANDLED;
		}
		else {
			return PLUGIN_CONTINUE;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		if (UserTimers[UserIndex] != 0) {
			kill_timer(UserTimers[UserIndex]);
			UserTimers[UserIndex] = 0;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("Admin CoAdmins Plugin","Setting names for CoAdmins.",STRING_VERSION);

	set_timer("CheckNameAll", 60, 99999);
	
	return PLUGIN_CONTINUE;	
}

